searchData={"items":[{"type":"module","title":"SPARQL","doc":"An implementation of the [SPARQL](http://www.w3.org/TR/sparql11-overview/) standard for Elixir.","ref":"SPARQL.html"},{"type":"function","title":"SPARQL.execute_query/2","doc":"Alias for `SPARQL.Processor.query/2`.","ref":"SPARQL.html#execute_query/2"},{"type":"function","title":"SPARQL.execute_query/3","doc":"Alias for `SPARQL.Processor.query/3`.","ref":"SPARQL.html#execute_query/3"},{"type":"function","title":"SPARQL.query/1","doc":"Alias for `SPARQL.Query.new/1`.","ref":"SPARQL.html#query/1"},{"type":"function","title":"SPARQL.query/2","doc":"Alias for `SPARQL.Query.new/2`.","ref":"SPARQL.html#query/2"},{"type":"function","title":"SPARQL.result_format/1","doc":"Returns the `SPARQL.Query.Result.Format` with the given name.\n\nReturns `nil` if no `SPARQL.Query.Result.Format` with the given name exists.","ref":"SPARQL.html#result_format/1"},{"type":"function","title":"SPARQL.result_format_by_extension/1","doc":"Returns the `SPARQL.Query.Result.Format` with the given file extension.\n\nReturns `nil` if no `SPARQL.Query.Result.Format` for the given file extension exists.","ref":"SPARQL.html#result_format_by_extension/1"},{"type":"function","title":"SPARQL.result_format_by_media_type/1","doc":"Returns the `SPARQL.Query.Result.Format` with the given media type.\n\nReturns `nil` if no `SPARQL.Query.Result.Format` for the given media type exists.","ref":"SPARQL.html#result_format_by_media_type/1"},{"type":"function","title":"SPARQL.result_formats/0","doc":"The list of all support `SPARQL.Query.Result.Format`s.","ref":"SPARQL.html#result_formats/0"},{"type":"module","title":"SPARQL.Algebra.BGP","doc":"","ref":"SPARQL.Algebra.BGP.html"},{"type":"function","title":"SPARQL.Algebra.BGP.solutions/2","doc":"","ref":"SPARQL.Algebra.BGP.html#solutions/2"},{"type":"function","title":"SPARQL.Algebra.BGP.variables/1","doc":"","ref":"SPARQL.Algebra.BGP.html#variables/1"},{"type":"function","title":"SPARQL.Algebra.BGP.zero/0","doc":"","ref":"SPARQL.Algebra.BGP.html#zero/0"},{"type":"module","title":"SPARQL.Algebra.Construct","doc":"","ref":"SPARQL.Algebra.Construct.html"},{"type":"function","title":"SPARQL.Algebra.Construct.result/4","doc":"","ref":"SPARQL.Algebra.Construct.html#result/4"},{"type":"module","title":"SPARQL.Algebra.Distinct","doc":"","ref":"SPARQL.Algebra.Distinct.html"},{"type":"function","title":"SPARQL.Algebra.Distinct.result_set/1","doc":"","ref":"SPARQL.Algebra.Distinct.html#result_set/1"},{"type":"protocol","title":"SPARQL.Algebra.Expression","doc":"","ref":"SPARQL.Algebra.Expression.html"},{"type":"function","title":"SPARQL.Algebra.Expression.evaluate/3","doc":"","ref":"SPARQL.Algebra.Expression.html#evaluate/3"},{"type":"function","title":"SPARQL.Algebra.Expression.variables/1","doc":"","ref":"SPARQL.Algebra.Expression.html#variables/1"},{"type":"type","title":"SPARQL.Algebra.Expression.t/0","doc":"All the types that implement this protocol.","ref":"SPARQL.Algebra.Expression.html#t:t/0"},{"type":"module","title":"SPARQL.Algebra.Extend","doc":"","ref":"SPARQL.Algebra.Extend.html"},{"type":"function","title":"SPARQL.Algebra.Extend.result_set/5","doc":"","ref":"SPARQL.Algebra.Extend.html#result_set/5"},{"type":"module","title":"SPARQL.Algebra.Filter","doc":"","ref":"SPARQL.Algebra.Filter.html"},{"type":"function","title":"SPARQL.Algebra.Filter.apply?/4","doc":"","ref":"SPARQL.Algebra.Filter.html#apply?/4"},{"type":"function","title":"SPARQL.Algebra.Filter.result_set/4","doc":"","ref":"SPARQL.Algebra.Filter.html#result_set/4"},{"type":"module","title":"SPARQL.Algebra.FunctionCall","doc":"Shared functions for builtin and extension function calls.","ref":"SPARQL.Algebra.FunctionCall.html"},{"type":"function","title":"SPARQL.Algebra.FunctionCall.evaluate_argument/3","doc":"","ref":"SPARQL.Algebra.FunctionCall.html#evaluate_argument/3"},{"type":"function","title":"SPARQL.Algebra.FunctionCall.evaluate_arguments/3","doc":"Evaluates argument expressions.\n\nAn unbound variable is evaluated to the value `:error`.","ref":"SPARQL.Algebra.FunctionCall.html#evaluate_arguments/3"},{"type":"module","title":"SPARQL.Algebra.FunctionCall.Builtin","doc":"","ref":"SPARQL.Algebra.FunctionCall.Builtin.html"},{"type":"function","title":"SPARQL.Algebra.FunctionCall.Builtin.invoke/4","doc":"Invokes a SPARQL builtin function.\n\nFor most functions this is done by delegating to `SPARQL.Functions.Builtins.call/2`.\nHowever, some functions have special \"functional forms\" which have different\nevaluation rules. All of these are implemented here directly.\n\nsee","ref":"SPARQL.Algebra.FunctionCall.Builtin.html#invoke/4"},{"type":"module","title":"SPARQL.Algebra.FunctionCall.Extension","doc":"","ref":"SPARQL.Algebra.FunctionCall.Extension.html"},{"type":"module","title":"SPARQL.Algebra.Join","doc":"","ref":"SPARQL.Algebra.Join.html"},{"type":"function","title":"SPARQL.Algebra.Join.result_set/2","doc":"","ref":"SPARQL.Algebra.Join.html#result_set/2"},{"type":"module","title":"SPARQL.Algebra.LeftJoin","doc":"","ref":"SPARQL.Algebra.LeftJoin.html"},{"type":"function","title":"SPARQL.Algebra.LeftJoin.result_set/5","doc":"","ref":"SPARQL.Algebra.LeftJoin.html#result_set/5"},{"type":"module","title":"SPARQL.Algebra.Minus","doc":"","ref":"SPARQL.Algebra.Minus.html"},{"type":"function","title":"SPARQL.Algebra.Minus.minus/2","doc":"","ref":"SPARQL.Algebra.Minus.html#minus/2"},{"type":"function","title":"SPARQL.Algebra.Minus.result_set/2","doc":"","ref":"SPARQL.Algebra.Minus.html#result_set/2"},{"type":"module","title":"SPARQL.Algebra.Project","doc":"","ref":"SPARQL.Algebra.Project.html"},{"type":"function","title":"SPARQL.Algebra.Project.result_set/2","doc":"","ref":"SPARQL.Algebra.Project.html#result_set/2"},{"type":"function","title":"SPARQL.Algebra.Project.solution/2","doc":"","ref":"SPARQL.Algebra.Project.html#solution/2"},{"type":"module","title":"SPARQL.Algebra.Reduced","doc":"","ref":"SPARQL.Algebra.Reduced.html"},{"type":"function","title":"SPARQL.Algebra.Reduced.result_set/1","doc":"","ref":"SPARQL.Algebra.Reduced.html#result_set/1"},{"type":"module","title":"SPARQL.Algebra.Translation","doc":"Translation of ASTs of the `SPARQL.Language.Decoder` into a `SPARQL.Algebra.Expression`.","ref":"SPARQL.Algebra.Translation.html"},{"type":"function","title":"SPARQL.Algebra.Translation.translate/4","doc":"","ref":"SPARQL.Algebra.Translation.html#translate/4"},{"type":"function","title":"SPARQL.Algebra.Translation.translate_exists_patterns/1","doc":"","ref":"SPARQL.Algebra.Translation.html#translate_exists_patterns/1"},{"type":"function","title":"SPARQL.Algebra.Translation.translate_triples_block/1","doc":"","ref":"SPARQL.Algebra.Translation.html#translate_triples_block/1"},{"type":"module","title":"SPARQL.Algebra.Translation.GroupGraphPattern","doc":"","ref":"SPARQL.Algebra.Translation.GroupGraphPattern.html"},{"type":"module","title":"SPARQL.Algebra.Translation.OptionalGraphPattern","doc":"","ref":"SPARQL.Algebra.Translation.OptionalGraphPattern.html"},{"type":"module","title":"SPARQL.Algebra.Union","doc":"","ref":"SPARQL.Algebra.Union.html"},{"type":"function","title":"SPARQL.Algebra.Union.result_set/2","doc":"","ref":"SPARQL.Algebra.Union.html#result_set/2"},{"type":"function","title":"SPARQL.Algebra.Union.variables/2","doc":"","ref":"SPARQL.Algebra.Union.html#variables/2"},{"type":"behaviour","title":"SPARQL.ExtensionFunction","doc":"A behaviour for SPARQL extension functions.","ref":"SPARQL.ExtensionFunction.html"},{"type":"behaviour","title":"Examples - SPARQL.ExtensionFunction","doc":"An extension function can be defined like this:\n\n    defmodule ExampleFunction do\n      use SPARQL.ExtensionFunction, name: \"http://example.com/function\"\n\n      def call(distinct, arguments, data, execution) do\n        # your implementation\n      end\n    end\n\nThe name of the module is arbitrary and has no further meaning.\n\nsee\n-  \n-","ref":"SPARQL.ExtensionFunction.html#module-examples"},{"type":"callback","title":"SPARQL.ExtensionFunction.call/4","doc":"Calls the extension function.\n\nThe `distinct` argument is a boolean flag  which signifies if the `DISTINCT`\nmodifier was used in the function call, which is syntactically allowed in\ncustom aggregate function calls only.\n\nThe `arguments` argument is the list of already evaluated RDF terms with which\nthe extension function was called in the SPARQL query.\n\nThe `data` argument contains the currently evaluated solution and some other\ninternal information and shouldn't be relied upon, because it might be subject\nto changes and contain different elements depending on the context the function\nwas called in. Since the arguments are already evaluated against the current\nsolution it shouldn't be necessary anyway.\n\nThe `execution` argument is a map with some global execution context\ninformation. In particular:\n\n- `base`: the base IRI\n- `time`: the query execution time\n- `bnode_generator`: the name of the `RDF.BlankNode.Generator` (see\n  [RDF.ex documentation](http://hexdocs.pm/rdf)) used to generate unique blank\n  nodes consistently","ref":"SPARQL.ExtensionFunction.html#c:call/4"},{"type":"callback","title":"SPARQL.ExtensionFunction.name/0","doc":"The name of the extension function.\n\nAs specified in the SPARQL grammar the name of a function is an IRI.","ref":"SPARQL.ExtensionFunction.html#c:name/0"},{"type":"module","title":"SPARQL.ExtensionFunction.Registration","doc":"","ref":"SPARQL.ExtensionFunction.Registration.html"},{"type":"function","title":"SPARQL.ExtensionFunction.Registration.extension_function/1","doc":"","ref":"SPARQL.ExtensionFunction.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.ExtensionFunction.Registry","doc":"A registry of all available `SPARQL.ExtensionFunction`s.","ref":"SPARQL.ExtensionFunction.Registry.html"},{"type":"function","title":"SPARQL.ExtensionFunction.Registry.extension_function/1","doc":"Returns the extension for the given name.\n\nIf no function for the given name exists, `nil` is returned.","ref":"SPARQL.ExtensionFunction.Registry.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Builtins","doc":"","ref":"SPARQL.Functions.Builtins.html"},{"type":"function","title":"SPARQL.Functions.Builtins.call/3","doc":"Returns the SHA256 checksum, as a hex digit string.\n\n-","ref":"SPARQL.Functions.Builtins.html#call/3"},{"type":"function","title":"SPARQL.Functions.Builtins.compatible_arguments?/2","doc":"Argument Compatibility Rules\n\nsee","ref":"SPARQL.Functions.Builtins.html#compatible_arguments?/2"},{"type":"module","title":"SPARQL.Functions.Cast","doc":"","ref":"SPARQL.Functions.Cast.html"},{"type":"module","title":"SPARQL.Functions.Cast.Boolean","doc":"An `SPARQL.ExtensionFunction` for the `xsd:boolean` XPath constructor function.\n\nSee:\n\n-  \n-","ref":"SPARQL.Functions.Cast.Boolean.html"},{"type":"function","title":"SPARQL.Functions.Cast.Boolean.call/4","doc":"","ref":"SPARQL.Functions.Cast.Boolean.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.Boolean.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Boolean.Registration","doc":"","ref":"SPARQL.Functions.Cast.Boolean.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Boolean.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.Boolean.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Boolean.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.Boolean.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Boolean.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.Date","doc":"An `SPARQL.ExtensionFunction` for the `xsd:date` XPath constructor function.\n\nNote: This is not required to be implemented on all SPARQL processing engines,\nso a query using this function might not be portable.\n\nSee:","ref":"SPARQL.Functions.Cast.Date.html"},{"type":"function","title":"SPARQL.Functions.Cast.Date.call/4","doc":"","ref":"SPARQL.Functions.Cast.Date.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.Date.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Date.Registration","doc":"","ref":"SPARQL.Functions.Cast.Date.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Date.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.Date.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Date.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.Date.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Date.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.DateTime","doc":"An `SPARQL.ExtensionFunction` for the `xsd:dateTime` XPath constructor function.\n\nSee:\n\n-  \n-","ref":"SPARQL.Functions.Cast.DateTime.html"},{"type":"function","title":"SPARQL.Functions.Cast.DateTime.call/4","doc":"","ref":"SPARQL.Functions.Cast.DateTime.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.DateTime.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.DateTime.Registration","doc":"","ref":"SPARQL.Functions.Cast.DateTime.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.DateTime.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.DateTime.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.DateTime.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.DateTime.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.DateTime.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.Decimal","doc":"An `SPARQL.ExtensionFunction` for the `xsd:decimal` XPath constructor function.\n\nSee:\n\n-  \n-","ref":"SPARQL.Functions.Cast.Decimal.html"},{"type":"function","title":"SPARQL.Functions.Cast.Decimal.call/4","doc":"","ref":"SPARQL.Functions.Cast.Decimal.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.Decimal.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Decimal.Registration","doc":"","ref":"SPARQL.Functions.Cast.Decimal.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Decimal.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.Decimal.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Decimal.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.Decimal.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Decimal.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.Double","doc":"An `SPARQL.ExtensionFunction` for the `xsd:double` XPath constructor function.\n\nSee:\n\n-  \n-","ref":"SPARQL.Functions.Cast.Double.html"},{"type":"function","title":"SPARQL.Functions.Cast.Double.call/4","doc":"","ref":"SPARQL.Functions.Cast.Double.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.Double.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Double.Registration","doc":"","ref":"SPARQL.Functions.Cast.Double.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Double.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.Double.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Double.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.Double.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Double.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.Float","doc":"An `SPARQL.ExtensionFunction` for the `xsd:float` XPath constructor function.\n\nSee:\n\n-  \n-","ref":"SPARQL.Functions.Cast.Float.html"},{"type":"function","title":"SPARQL.Functions.Cast.Float.call/4","doc":"","ref":"SPARQL.Functions.Cast.Float.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.Float.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Float.Registration","doc":"","ref":"SPARQL.Functions.Cast.Float.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Float.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.Float.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Float.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.Float.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Float.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.Integer","doc":"An `SPARQL.ExtensionFunction` for the `xsd:integer` XPath constructor function.\n\nSee:\n\n-  \n-","ref":"SPARQL.Functions.Cast.Integer.html"},{"type":"function","title":"SPARQL.Functions.Cast.Integer.call/4","doc":"","ref":"SPARQL.Functions.Cast.Integer.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.Integer.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Integer.Registration","doc":"","ref":"SPARQL.Functions.Cast.Integer.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Integer.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.Integer.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Integer.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.Integer.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Integer.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.String","doc":"An `SPARQL.ExtensionFunction` for the `xsd:string` XPath constructor function.\n\nSee:\n\n-  \n-","ref":"SPARQL.Functions.Cast.String.html"},{"type":"function","title":"SPARQL.Functions.Cast.String.call/4","doc":"","ref":"SPARQL.Functions.Cast.String.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.String.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.String.Registration","doc":"","ref":"SPARQL.Functions.Cast.String.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.String.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.String.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.String.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.String.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.String.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Functions.Cast.Time","doc":"An `SPARQL.ExtensionFunction` for the `xsd:time` XPath constructor function.\n\nNote: This is not required to be implemented on all SPARQL processing engines,\nso a query using this function might not be portable.\n\nSee:","ref":"SPARQL.Functions.Cast.Time.html"},{"type":"function","title":"SPARQL.Functions.Cast.Time.call/4","doc":"","ref":"SPARQL.Functions.Cast.Time.html#call/4"},{"type":"module","title":"SPARQL.Functions.Cast.Time.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Time.Registration","doc":"","ref":"SPARQL.Functions.Cast.Time.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Time.Registration.html"},{"type":"function","title":"SPARQL.Functions.Cast.Time.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Time.Registration.extension_function/1","doc":"","ref":"SPARQL.Functions.Cast.Time.SPARQL.ExtensionFunction.Registration.SPARQL.Functions.Cast.Time.Registration.html#extension_function/1"},{"type":"module","title":"SPARQL.Language","doc":"An implementation of the SPARQL 1.1 query language.\n\nsee","ref":"SPARQL.Language.html"},{"type":"function","title":"SPARQL.Language.file_extension/0","doc":"","ref":"SPARQL.Language.html#file_extension/0"},{"type":"function","title":"SPARQL.Language.media_type/0","doc":"","ref":"SPARQL.Language.html#media_type/0"},{"type":"function","title":"SPARQL.Language.parse/2","doc":"","ref":"SPARQL.Language.html#parse/2"},{"type":"module","title":"SPARQL.Language.Decoder","doc":"","ref":"SPARQL.Language.Decoder.html"},{"type":"function","title":"SPARQL.Language.Decoder.ast/1","doc":"","ref":"SPARQL.Language.Decoder.html#ast/1"},{"type":"function","title":"SPARQL.Language.Decoder.decode/2","doc":"","ref":"SPARQL.Language.Decoder.html#decode/2"},{"type":"module","title":"SPARQL.Language.ParseHelper","doc":"","ref":"SPARQL.Language.ParseHelper.html"},{"type":"function","title":"SPARQL.Language.ParseHelper.arithmetic_expr/1","doc":"","ref":"SPARQL.Language.ParseHelper.html#arithmetic_expr/1"},{"type":"function","title":"SPARQL.Language.ParseHelper.arithmetic_expr/2","doc":"","ref":"SPARQL.Language.ParseHelper.html#arithmetic_expr/2"},{"type":"function","title":"SPARQL.Language.ParseHelper.arithmetic_expr/3","doc":"","ref":"SPARQL.Language.ParseHelper.html#arithmetic_expr/3"},{"type":"function","title":"SPARQL.Language.ParseHelper.arithmetic_quirk_expr/4","doc":"","ref":"SPARQL.Language.ParseHelper.html#arithmetic_quirk_expr/4"},{"type":"function","title":"SPARQL.Language.ParseHelper.extract_literal/1","doc":"","ref":"SPARQL.Language.ParseHelper.html#extract_literal/1"},{"type":"function","title":"SPARQL.Language.ParseHelper.multiplicative_expr/3","doc":"","ref":"SPARQL.Language.ParseHelper.html#multiplicative_expr/3"},{"type":"function","title":"SPARQL.Language.ParseHelper.multiplicative_quirk_expr/3","doc":"","ref":"SPARQL.Language.ParseHelper.html#multiplicative_quirk_expr/3"},{"type":"function","title":"SPARQL.Language.ParseHelper.strip_sign/1","doc":"","ref":"SPARQL.Language.ParseHelper.html#strip_sign/1"},{"type":"function","title":"SPARQL.Language.ParseHelper.variable/1","doc":"","ref":"SPARQL.Language.ParseHelper.html#variable/1"},{"type":"module","title":"SPARQL.Processor","doc":"Context module for the SPARQL processor executing SPARQL queries and updates.","ref":"SPARQL.Processor.html"},{"type":"function","title":"SPARQL.Processor.query/3","doc":"Executes a `SPARQL.Query` or string with a SPARQL string against a `RDF.Data` structure.","ref":"SPARQL.Processor.html#query/3"},{"type":"function","title":"SPARQL.Processor.query_post_processing/1","doc":"","ref":"SPARQL.Processor.html#query_post_processing/1"},{"type":"module","title":"SPARQL.Query","doc":"A structure for SPARQL queries.","ref":"SPARQL.Query.html"},{"type":"function","title":"SPARQL.Query.new/2","doc":"Creates a `SPARQL.Query` struct.\n\nSee `translate/2` for more information about default prefixes, all of which\napplies also to this function.","ref":"SPARQL.Query.html#new/2"},{"type":"function","title":"SPARQL.Query.translate/2","doc":"Creates a `SPARQL.Query` struct from a SPARQL language string.\n\nBy default, the configured `RDF.default_prefixes/0` will be automatically\ndefined for the query, so that you can use these prefixes without having them\ndefined manually in your query.\nYou can overwrite these default prefixes and define another set of prefixes\nwith the `default_prefixes` option.\nIf you don't want to use default prefixes for the given query you\ncan pass `nil` or an empty map for the `default_prefixes` option.\n\nIf you don't want to use default prefixes at all, just don't configure any and\nset the `rdf` configuration flag `use_standard_prefixes` to `false`.\nSee the [API documentation of RDF.ex](https://hexdocs.pm/rdf/RDF.html) for\nfor more information about `RDF.default_prefixes/0` and `RDF.standard_prefixes/0`\nand how to configure them.","ref":"SPARQL.Query.html#translate/2"},{"type":"type","title":"SPARQL.Query.forms/0","doc":"","ref":"SPARQL.Query.html#t:forms/0"},{"type":"type","title":"SPARQL.Query.t/0","doc":"","ref":"SPARQL.Query.html#t:t/0"},{"type":"module","title":"SPARQL.Query.Result","doc":"","ref":"SPARQL.Query.Result.html"},{"type":"function","title":"SPARQL.Query.Result.get/2","doc":"Returns the solutions for the given variable.","ref":"SPARQL.Query.Result.html#get/2"},{"type":"function","title":"SPARQL.Query.Result.new/2","doc":"","ref":"SPARQL.Query.Result.html#new/2"},{"type":"type","title":"SPARQL.Query.Result.t/0","doc":"","ref":"SPARQL.Query.Result.html#t:t/0"},{"type":"module","title":"SPARQL.Query.Result.CSV","doc":"An implementation of the W3C Recommendation for the SPARQL 1.1 Query Results CSV Formats.\n\nsee","ref":"SPARQL.Query.Result.CSV.html"},{"type":"function","title":"SPARQL.Query.Result.CSV.decode/2","doc":"","ref":"SPARQL.Query.Result.CSV.html#decode/2"},{"type":"function","title":"SPARQL.Query.Result.CSV.decode!/2","doc":"","ref":"SPARQL.Query.Result.CSV.html#decode!/2"},{"type":"function","title":"SPARQL.Query.Result.CSV.decoder/0","doc":"","ref":"SPARQL.Query.Result.CSV.html#decoder/0"},{"type":"function","title":"SPARQL.Query.Result.CSV.encoder/0","doc":"","ref":"SPARQL.Query.Result.CSV.html#encoder/0"},{"type":"function","title":"SPARQL.Query.Result.CSV.extension/0","doc":"","ref":"SPARQL.Query.Result.CSV.html#extension/0"},{"type":"function","title":"SPARQL.Query.Result.CSV.id/0","doc":"","ref":"SPARQL.Query.Result.CSV.html#id/0"},{"type":"function","title":"SPARQL.Query.Result.CSV.media_type/0","doc":"","ref":"SPARQL.Query.Result.CSV.html#media_type/0"},{"type":"function","title":"SPARQL.Query.Result.CSV.name/0","doc":"","ref":"SPARQL.Query.Result.CSV.html#name/0"},{"type":"function","title":"SPARQL.Query.Result.CSV.read_string/2","doc":"","ref":"SPARQL.Query.Result.CSV.html#read_string/2"},{"type":"function","title":"SPARQL.Query.Result.CSV.supported_query_forms/0","doc":"","ref":"SPARQL.Query.Result.CSV.html#supported_query_forms/0"},{"type":"behaviour","title":"SPARQL.Query.Result.Format","doc":"A behaviour for SPARQL query result formats.\n\nA `SPARQL.Query.Result.Format` for a format can be implemented like this\n\n    defmodule SomeFormat do\n      use SPARQL.Query.Result.Format\n      import RDF.Sigils\n\n      @id         ~I \n      @name       :some_format\n      @extension  \"ext\"\n      @media_type \"application/some-format\"\n    end\n\nWhen `@id`, `@name`, `@extension` and `@media_type` module attributes are\ndefined the resp. behaviour functions are generated automatically and return\nthese values.\n\nThen you'll have to do the main work by implementing a\n`RDF.Serialization.Encoder` and a `RDF.Serialization.Decoder` for the format.\n\nBy default, it is assumed that these are defined in `Encoder` and `Decoder`\nmodules under the module of the format, i.e. in the example above in\n`SomeFormat.Encoder` and `SomeFormat.Decoder`.\nIf you want them in another module, you'll have to override the `encoder/0`\nand/or `decoder/0` functions in your `SPARQL.Query.Result.Format` module.","ref":"SPARQL.Query.Result.Format.html"},{"type":"callback","title":"SPARQL.Query.Result.Format.decoder/0","doc":"The `SPARQL.Query.Result.Format.Decoder` module for the result format.","ref":"SPARQL.Query.Result.Format.html#c:decoder/0"},{"type":"callback","title":"SPARQL.Query.Result.Format.encoder/0","doc":"The `SPARQL.Query.Result.Format.Encoder` module for the result format.","ref":"SPARQL.Query.Result.Format.html#c:encoder/0"},{"type":"callback","title":"SPARQL.Query.Result.Format.extension/0","doc":"The usual file extension for the SPARQL query result format.","ref":"SPARQL.Query.Result.Format.html#c:extension/0"},{"type":"callback","title":"SPARQL.Query.Result.Format.id/0","doc":"An IRI of the SPARQL query result format.","ref":"SPARQL.Query.Result.Format.html#c:id/0"},{"type":"callback","title":"SPARQL.Query.Result.Format.media_type/0","doc":"The MIME type of the SPARQL query result format.","ref":"SPARQL.Query.Result.Format.html#c:media_type/0"},{"type":"callback","title":"SPARQL.Query.Result.Format.name/0","doc":"An name atom of the SPARQL query result format under which it can referenced.","ref":"SPARQL.Query.Result.Format.html#c:name/0"},{"type":"callback","title":"SPARQL.Query.Result.Format.supported_query_forms/0","doc":"A list of the supported query forms of the SPARQL query result format.","ref":"SPARQL.Query.Result.Format.html#c:supported_query_forms/0"},{"type":"behaviour","title":"SPARQL.Query.Result.Format.Decoder","doc":"A behaviour for decoders of strings encoded in a specific `SPARQL.Query.Result.Format`.","ref":"SPARQL.Query.Result.Format.Decoder.html"},{"type":"callback","title":"SPARQL.Query.Result.Format.Decoder.decode/2","doc":"Decodes a serialized `SPARQL.Query.Result` from the given string.\n\nIt returns an `{:ok, result_set}` tuple or `{:error, reason}` if an error occurs.","ref":"SPARQL.Query.Result.Format.Decoder.html#c:decode/2"},{"type":"callback","title":"SPARQL.Query.Result.Format.Decoder.decode!/2","doc":"Decodes a serialized `SPARQL.Query.Result` from the given string.\n\nAs opposed to `decode`, it raises an exception if an error occurs.\n\nNote: The `__using__` macro automatically provides an overridable default\nimplementation based on the non-bang `decode` function.","ref":"SPARQL.Query.Result.Format.Decoder.html#c:decode!/2"},{"type":"behaviour","title":"SPARQL.Query.Result.Format.Encoder","doc":"A behaviour for encoders of `SPARQL.Query.Result`s in a specific `SPARQL.Query.Result.Format`s.","ref":"SPARQL.Query.Result.Format.Encoder.html"},{"type":"callback","title":"SPARQL.Query.Result.Format.Encoder.encode/2","doc":"Encodes a `SPARQL.Query.Result`.\n\nIt returns an `{:ok, string}` tuple, with `string` being the serialized\n`SPARQL.Query.Result`, or `{:error, reason}` if an error occurs.","ref":"SPARQL.Query.Result.Format.Encoder.html#c:encode/2"},{"type":"callback","title":"SPARQL.Query.Result.Format.Encoder.encode!/2","doc":"Encodes a `SPARQL.Query.Result`.\n\nAs opposed to `encode`, it raises an exception if an error occurs.\n\nNote: The `__using__` macro automatically provides an overridable default\nimplementation based on the non-bang `encode` function.","ref":"SPARQL.Query.Result.Format.Encoder.html#c:encode!/2"},{"type":"module","title":"SPARQL.Query.Result.JSON","doc":"An implementation of the W3C Recommendation for the SPARQL 1.1 Query Results JSON Format.\n\nsee","ref":"SPARQL.Query.Result.JSON.html"},{"type":"function","title":"SPARQL.Query.Result.JSON.decode/2","doc":"","ref":"SPARQL.Query.Result.JSON.html#decode/2"},{"type":"function","title":"SPARQL.Query.Result.JSON.decode!/2","doc":"","ref":"SPARQL.Query.Result.JSON.html#decode!/2"},{"type":"function","title":"SPARQL.Query.Result.JSON.decoder/0","doc":"","ref":"SPARQL.Query.Result.JSON.html#decoder/0"},{"type":"function","title":"SPARQL.Query.Result.JSON.encoder/0","doc":"","ref":"SPARQL.Query.Result.JSON.html#encoder/0"},{"type":"function","title":"SPARQL.Query.Result.JSON.extension/0","doc":"","ref":"SPARQL.Query.Result.JSON.html#extension/0"},{"type":"function","title":"SPARQL.Query.Result.JSON.id/0","doc":"","ref":"SPARQL.Query.Result.JSON.html#id/0"},{"type":"function","title":"SPARQL.Query.Result.JSON.media_type/0","doc":"","ref":"SPARQL.Query.Result.JSON.html#media_type/0"},{"type":"function","title":"SPARQL.Query.Result.JSON.name/0","doc":"","ref":"SPARQL.Query.Result.JSON.html#name/0"},{"type":"function","title":"SPARQL.Query.Result.JSON.read_string/2","doc":"","ref":"SPARQL.Query.Result.JSON.html#read_string/2"},{"type":"function","title":"SPARQL.Query.Result.JSON.supported_query_forms/0","doc":"","ref":"SPARQL.Query.Result.JSON.html#supported_query_forms/0"},{"type":"module","title":"SPARQL.Query.Result.TSV","doc":"An implementation of the W3C Recommendation for the SPARQL 1.1 Query Results TSV Formats.\n\nsee","ref":"SPARQL.Query.Result.TSV.html"},{"type":"function","title":"SPARQL.Query.Result.TSV.decode/2","doc":"","ref":"SPARQL.Query.Result.TSV.html#decode/2"},{"type":"function","title":"SPARQL.Query.Result.TSV.decode!/2","doc":"","ref":"SPARQL.Query.Result.TSV.html#decode!/2"},{"type":"function","title":"SPARQL.Query.Result.TSV.decoder/0","doc":"","ref":"SPARQL.Query.Result.TSV.html#decoder/0"},{"type":"function","title":"SPARQL.Query.Result.TSV.encoder/0","doc":"","ref":"SPARQL.Query.Result.TSV.html#encoder/0"},{"type":"function","title":"SPARQL.Query.Result.TSV.extension/0","doc":"","ref":"SPARQL.Query.Result.TSV.html#extension/0"},{"type":"function","title":"SPARQL.Query.Result.TSV.id/0","doc":"","ref":"SPARQL.Query.Result.TSV.html#id/0"},{"type":"function","title":"SPARQL.Query.Result.TSV.media_type/0","doc":"","ref":"SPARQL.Query.Result.TSV.html#media_type/0"},{"type":"function","title":"SPARQL.Query.Result.TSV.name/0","doc":"","ref":"SPARQL.Query.Result.TSV.html#name/0"},{"type":"function","title":"SPARQL.Query.Result.TSV.read_string/2","doc":"","ref":"SPARQL.Query.Result.TSV.html#read_string/2"},{"type":"function","title":"SPARQL.Query.Result.TSV.supported_query_forms/0","doc":"","ref":"SPARQL.Query.Result.TSV.html#supported_query_forms/0"},{"type":"module","title":"SPARQL.Query.Result.Turtle","doc":"An implementation of the Turtle serialization of SPARQL Query Results used in some W3C SPARQL tests.","ref":"SPARQL.Query.Result.Turtle.html"},{"type":"function","title":"SPARQL.Query.Result.Turtle.decode/2","doc":"","ref":"SPARQL.Query.Result.Turtle.html#decode/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.decode!/2","doc":"","ref":"SPARQL.Query.Result.Turtle.html#decode!/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.decoder/0","doc":"","ref":"SPARQL.Query.Result.Turtle.html#decoder/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.encoder/0","doc":"","ref":"SPARQL.Query.Result.Turtle.html#encoder/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.extension/0","doc":"","ref":"SPARQL.Query.Result.Turtle.html#extension/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.id/0","doc":"","ref":"SPARQL.Query.Result.Turtle.html#id/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.media_type/0","doc":"","ref":"SPARQL.Query.Result.Turtle.html#media_type/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.name/0","doc":"","ref":"SPARQL.Query.Result.Turtle.html#name/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.read_string/2","doc":"","ref":"SPARQL.Query.Result.Turtle.html#read_string/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.supported_query_forms/0","doc":"","ref":"SPARQL.Query.Result.Turtle.html#supported_query_forms/0"},{"type":"module","title":"SPARQL.Query.Result.Turtle.NS","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.html"},{"type":"module","title":"SPARQL.Query.Result.Turtle.NS.RS","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.__iris__/0","doc":"Returns all known IRIs of the vocabulary.","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#__iris__/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.binding/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#binding/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.binding/1","doc":"`RDF.Description` property accessor for `binding/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#binding/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.binding/2","doc":"`RDF.Description` builder for `binding/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#binding/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.boolean/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#boolean/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.boolean/1","doc":"`RDF.Description` property accessor for `boolean/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#boolean/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.boolean/2","doc":"`RDF.Description` builder for `boolean/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#boolean/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.index/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#index/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.index/1","doc":"`RDF.Description` property accessor for `index/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#index/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.index/2","doc":"`RDF.Description` builder for `index/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#index/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.resultVariable/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#resultVariable/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.resultVariable/1","doc":"`RDF.Description` property accessor for `resultVariable/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#resultVariable/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.resultVariable/2","doc":"`RDF.Description` builder for `resultVariable/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#resultVariable/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.size/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#size/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.size/1","doc":"`RDF.Description` property accessor for `size/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#size/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.size/2","doc":"`RDF.Description` builder for `size/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#size/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.solution/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#solution/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.solution/1","doc":"`RDF.Description` property accessor for `solution/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#solution/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.solution/2","doc":"`RDF.Description` builder for `solution/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#solution/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.value/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#value/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.value/1","doc":"`RDF.Description` property accessor for `value/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#value/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.value/2","doc":"`RDF.Description` builder for `value/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#value/2"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.variable/0","doc":"","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#variable/0"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.variable/1","doc":"`RDF.Description` property accessor for `variable/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#variable/1"},{"type":"function","title":"SPARQL.Query.Result.Turtle.NS.RS.variable/2","doc":"`RDF.Description` builder for `variable/0`","ref":"SPARQL.Query.Result.Turtle.NS.RS.html#variable/2"},{"type":"module","title":"SPARQL.Query.Result.XML","doc":"An implementation of the W3C Recommendation for the SPARQL 1.1 Query Results XML Format.\n\nsee","ref":"SPARQL.Query.Result.XML.html"},{"type":"function","title":"SPARQL.Query.Result.XML.decode/2","doc":"","ref":"SPARQL.Query.Result.XML.html#decode/2"},{"type":"function","title":"SPARQL.Query.Result.XML.decode!/2","doc":"","ref":"SPARQL.Query.Result.XML.html#decode!/2"},{"type":"function","title":"SPARQL.Query.Result.XML.decoder/0","doc":"","ref":"SPARQL.Query.Result.XML.html#decoder/0"},{"type":"function","title":"SPARQL.Query.Result.XML.encoder/0","doc":"","ref":"SPARQL.Query.Result.XML.html#encoder/0"},{"type":"function","title":"SPARQL.Query.Result.XML.extension/0","doc":"","ref":"SPARQL.Query.Result.XML.html#extension/0"},{"type":"function","title":"SPARQL.Query.Result.XML.id/0","doc":"","ref":"SPARQL.Query.Result.XML.html#id/0"},{"type":"function","title":"SPARQL.Query.Result.XML.media_type/0","doc":"","ref":"SPARQL.Query.Result.XML.html#media_type/0"},{"type":"function","title":"SPARQL.Query.Result.XML.name/0","doc":"","ref":"SPARQL.Query.Result.XML.html#name/0"},{"type":"function","title":"SPARQL.Query.Result.XML.read_string/2","doc":"","ref":"SPARQL.Query.Result.XML.html#read_string/2"},{"type":"function","title":"SPARQL.Query.Result.XML.supported_query_forms/0","doc":"","ref":"SPARQL.Query.Result.XML.html#supported_query_forms/0"},{"type":"module","title":"TSV","doc":"","ref":"TSV.html"},{"type":"function","title":"TSV.dump_to_iodata/1","doc":"","ref":"TSV.html#dump_to_iodata/1"},{"type":"function","title":"TSV.dump_to_stream/1","doc":"","ref":"TSV.html#dump_to_stream/1"},{"type":"function","title":"TSV.parse_enumerable/2","doc":"","ref":"TSV.html#parse_enumerable/2"},{"type":"function","title":"TSV.parse_stream/2","doc":"","ref":"TSV.html#parse_stream/2"},{"type":"function","title":"TSV.parse_string/2","doc":"","ref":"TSV.html#parse_string/2"},{"type":"function","title":"TSV.to_line_stream/1","doc":"","ref":"TSV.html#to_line_stream/1"},{"type":"extras","title":"About","doc":"# SPARQL.ex\n\n[![CI](https://github.com/rdf-elixir/sparql-ex/actions/workflows/ci.yml/badge.svg)](https://github.com/rdf-elixir/sparql-ex/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/sparql.svg?style=flat-square)](https://hex.pm/packages/sparql)\n\n\nAn implementation of the [SPARQL] standards for Elixir.\n\nIt allows to execute SPARQL queries against [RDF.ex] data structures. With the separate [SPARQL.Client] package SPARQL queries can be executed against SPARQL protocol endpoints.\n\nThe API documentation can be found [here](https://hexdocs.pm/sparql/). For a guide and more information about SPARQL.ex and it's related projects, go to  .","ref":"readme.html"},{"type":"extras","title":"Current state - About","doc":"Note: **The [SPARQL.Client] supports the full SPARQL 1.1 query language**. The missing query language features in the following list are just not yet supported **by the query engine** executing queries against RDF.ex data structures.\n\n- [ ] SPARQL 1.1 Query Language\n    - [x] Basic Graph Pattern matching\n    - [x] Group Graph Pattern matching\n    - [x] Optional Graph Pattern matching via `OPTIONAL`\n    - [x] Alternative Graph Pattern matching via `UNION`\n    - [ ] Pattern matching on Named Graphs via `FROM` and `GRAPH`\n    - [ ] Solution sequence modification\n        - [x] Projection with the `SELECT` clause\n        - [x] Assignments to variables in the `SELECT` clause\n        - [x] `DISTINCT`\n        - [x] `REDUCED`\n        - [ ] `ORDER BY`\n        - [ ] `OFFSET`\n        - [ ] `LIMIT`\n    - [x] Restriction of solutions via `FILTER`\n    - [x] All builtin functions specified in SPARQL 1.0 and 1.1\n    - [x] Ability to define extension functions\n    - [x] All XPath constructor functions as specified in the SPARQL 1.1 spec\n    - [x] Assignments via `BIND`\n    - [x] Negation via `MINUS`\n    - [ ] Negation via `NOT EXIST`\n    - [ ] Inline Data via `VALUES`\n    - [ ] Aggregates via `GROUP BY` and `HAVING`\n    - [ ] Subqueries\n    - [ ] Property Paths\n    - [ ] `ASK` query form\n    - [ ] `DESCRIBE` query form\n    - [x] `CONSTRUCT` query form\n- [ ] SPARQL 1.1 Update\n- [x] SPARQL Query Results XML Format\n- [x] SPARQL 1.1 Query Results JSON Format\n- [x] SPARQL 1.1 Query Results CSV and TSV Formats\n- [x] SPARQL 1.1 Protocol (currently client-only; in a separate package: [sparql_client](https://github.com/rdf-elixir/sparql_client))\n- [ ] SPARQL 1.1 Graph Store HTTP Protocol\n- [ ] SPARQL 1.1 Service Description\n- [ ] SPARQL 1.1 Federated Query\n- [ ] SPARQL 1.1 Entailment Regimes\n\nOther features on the roadmap:\n\n- [ ] parallelization of the query execution\n- [ ] query DSL","ref":"readme.html#current-state"},{"type":"extras","title":"Contributing - About","doc":"see [CONTRIBUTING](CONTRIBUTING.md) for details.","ref":"readme.html#contributing"},{"type":"extras","title":"Consulting - About","doc":"If you need help with your Elixir and Linked Data projects, just contact [NinjaConcept](https://www.ninjaconcept.com/) via  .","ref":"readme.html#consulting"},{"type":"extras","title":"License and Copyright - About","doc":"(c) 2017-present Marcel Otto. MIT Licensed, see [LICENSE](LICENSE.md) for details.\n\n\n[SPARQL]:               http://www.w3.org/TR/sparql11-overview/\n[SPARQL.ex]:            https://hex.pm/packages/sparql\n[SPARQL.Client]:        https://hex.pm/packages/sparql_client\n[RDF.ex]:               https://hex.pm/packages/rdf","ref":"readme.html#license-and-copyright"},{"type":"extras","title":"CHANGELOG","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nThis project adheres to [Semantic Versioning](http://semver.org/) and\n[Keep a CHANGELOG](http://keepachangelog.com).","ref":"changelog.html"},{"type":"extras","title":"v0.3.10 - 2024-08-07 - CHANGELOG","doc":"This version is just upgraded to RDF.ex v2.0.\n\nElixir versions < 1.13 and OTP version < 23 are no longer supported","ref":"changelog.html#v0-3-10-2024-08-07"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- Replacement of `elixir_uuid` with `uniq` dependency\n\n\n[Compare v0.3.9...v0.3.10](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.9...v0.3.10)","ref":"changelog.html#changed"},{"type":"extras","title":"v0.3.9 - 2023-12-19 - CHANGELOG","doc":"Elixir versions < 1.12 are no longer supported","ref":"changelog.html#v0-3-9-2023-12-19"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- The internal SPARQL lexer and parser were renamed more uniquely.\n  A potential for collisions came to light after switching to\n  Elixir v1.15 where the new compilation behaviour was causing sometimes\n  interferences with another generically named parser, namely the one\n  from erlex (a dependency of dialyxir).\n\n[Compare v0.3.8...v0.3.9](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.8...v0.3.9)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.3.8 - 2022-11-03 - CHANGELOG","doc":"This version is just upgraded to RDF.ex 1.0.\n\nElixir versions < 1.11 are no longer supported\n\n[Compare v0.3.7...v0.3.8](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.7...v0.3.8)","ref":"changelog.html#v0-3-8-2022-11-03"},{"type":"extras","title":"v0.3.7 - 2022-03-22 - CHANGELOG","doc":"Upgrades to RDF.ex 0.11. Earlier version won't work with RDF.ex >= 0.11. \n\nElixir versions < 1.10 are no longer supported","ref":"changelog.html#v0-3-7-2022-03-22"},{"type":"extras","title":"Added - CHANGELOG","doc":"- Support for SPARQL-star query results JSON and XML formats\n\n[Compare v0.3.6...v0.3.7](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.6...v0.3.7)","ref":"changelog.html#added"},{"type":"extras","title":"v0.3.6 - 2020-09-21 - CHANGELOG","doc":"","ref":"changelog.html#v0-3-6-2020-09-21"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- The JSON query result decoder didn't recognize the datatype of literals when the JSON\n  value object was `\"type\" : \"literal\"`. Only for those with `\"typed-literal\"` the `\"datatype\"` \n  field was interpreted.    \n- Not all IRI values in CSV results were recognized as IRIs. Values starting with the most\n  common URI schemes (http/https, urn, ftp, file, ldap, mailto, geo, data) are now recognized \n  correctly. \n\n[Compare v0.3.5...v0.3.6](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.5...v0.3.6)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.3.5 - 2020-06-01 - CHANGELOG","doc":"","ref":"changelog.html#v0-3-5-2020-06-01"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- Upgrade to RDF.ex 0.8. With that Elixir versions < 1.8 are no longer supported.\n- the SPARQL extension function registry is now implemented with the ProtocolEx library,\n  improving the performance of queries using SPARQL extension functions (including the \n  builtin casting functions); unfortunately this means the `SPARQL.ExtensionFunction.Registry.get_all/0`\n  function to get all registered extension functions can no longer be supported \n\n[Compare v0.3.4...v0.3.5](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.4...v0.3.5)","ref":"changelog.html#changed"},{"type":"extras","title":"v0.3.4 - 2019-12-14 - CHANGELOG","doc":"- Upgrade to RDF.ex 0.7\n\n[Compare v0.3.3...v0.3.4](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.3...v0.3.4)","ref":"changelog.html#v0-3-4-2019-12-14"},{"type":"extras","title":"v0.3.3 - 2019-10-25 - CHANGELOG","doc":"","ref":"changelog.html#v0-3-3-2019-10-25"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- a bug in the BGP processing algorithm lead to wrong solutions when one triple \n  pattern in a BGP had no solutions \n\n\n[Compare v0.3.2...v0.3.3](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.2...v0.3.3)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.3.2 - 2019-09-08 - CHANGELOG","doc":"","ref":"changelog.html#v0-3-2-2019-09-08"},{"type":"extras","title":"Added - CHANGELOG","doc":"- `no_extension_detection_in_releases_warning` configuration which disables the  \n  warning that not all extension functions may be detected in a release with the\n  runtime system in interactive mode","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- Raise an error when the query uses an unknown prefix instead of producing an \n  invalid query\n\n\n[Compare v0.3.1...v0.3.2](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.1...v0.3.2)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.3.1 - 2019-07-15 - CHANGELOG","doc":"","ref":"changelog.html#v0-3-1-2019-07-15"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- Use the new `RDF.Literal.matches?/3` function from RDF.ex 0.6.1 for the `REGEX` function\n- with the fix from RDF.ex 0.6.1 XSD boolean with uppercase letters in the boolean\n  lexical values are no longer valid","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- the `true` and `false` keywords from the SPARQL language are case-insensitive\n- the new `RDF.Literal.matches?/3` function also fixes some Unicode escaping\n  issues in regular expressions\n\n\n[Compare v0.3.0...v0.3.1](https://github.com/rdf-elixir/sparql-ex/compare/v0.3.0...v0.3.1)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.3.0 - 2019-04-06 - CHANGELOG","doc":"","ref":"changelog.html#v0-3-0-2019-04-06"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- Replace the prefix management of SPARQL.ex with the new prefix management \n  capabilities of RDF.ex 0.6\n- Use the query prefixes as the prefixes of CONSTRUCTed graphs\n\n\n[Compare v0.2.9...v0.3.0](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.9...v0.3.0)","ref":"changelog.html#changed"},{"type":"extras","title":"v0.2.9 - 2019-03-06 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-9-2019-03-06"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- the application failed to start in OTP releases (#2)\n\n\n[Compare v0.2.8...v0.2.9](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.8...v0.2.9)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.2.8 - 2019-02-16 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-8-2019-02-16"},{"type":"extras","title":"Added - CHANGELOG","doc":"- Support for negations with `MINUS`\n\n\n[Compare v0.2.7...v0.2.8](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.7...v0.2.8)","ref":"changelog.html#added"},{"type":"extras","title":"v0.2.7 - 2018-11-11 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-7-2018-11-11"},{"type":"extras","title":"Added - CHANGELOG","doc":"- Support of the `CONSTRUCT` query form","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- various fixes on comparisons between `RDF.DateTime`s and `RDF.Date`s  \n\n\n[Compare v0.2.6...v0.2.7](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.6...v0.2.7)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.2.6 - 2018-10-30 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-6-2018-10-30"},{"type":"extras","title":"Added - CHANGELOG","doc":"- Support for alternative graph patterns with `UNION`\n- Support for assigning to variables with `BIND`","ref":"changelog.html#added"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- `REDUCED` no longer removes duplicates without projection (for performance reasons)","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- `DISTINCT` did not work without projection\n\n\n[Compare v0.2.5...v0.2.6](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.5...v0.2.6)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.2.5 - 2018-10-21 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-5-2018-10-21"},{"type":"extras","title":"Added - CHANGELOG","doc":"- Support for optional graph patterns via `OPTIONAL`\n- Support for the `bound` function","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- errors during evaluation of function arguments were handled incorrectly, \n  which led in particular to wrong behaviour of the `COALESCE` function\n- `SPARQL.Query.Result.get/2` failed when the given variable was not in the results\n\n\n[Compare v0.2.4...v0.2.5](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.4...v0.2.5)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.2.4 - 2018-10-06 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-4-2018-10-06"},{"type":"extras","title":"Added - CHANGELOG","doc":"- Support for group graph patterns, i.e. nested graph patterns and `FILTER`s in\n  the middle of a graph patterns (which splits up a graph pattern)\n- `SPARQL.Query.Result.get/2` as a short way for getting the solutions of a \n  single variable","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- `FILTER` expressions at the beginning of a graph pattern\n\n\n[Compare v0.2.3...v0.2.4](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.3...v0.2.4)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.2.3 - 2018-09-23 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-3-2018-09-23"},{"type":"extras","title":"Added - CHANGELOG","doc":"- evaluation of `DISTINCT` and `REDUCED` (the later having the semantics as \n  `DISTINCT`, i.e. no optimizations right now)\n- implementation of `String.Chars` protocol on `SPARQL.Query`","ref":"changelog.html#added"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- various refinements of default prefixes\n\t- renamed the query-specific default prefixes option from `prefixes` to `default_prefixes`\n\t- setting `none` on the `default_prefixes` option, removes the standard application-wide\n\t  configured default prefixes\n\t- `SPARQL.Processor.query` (and the `SPARQL.execute_query` alias) pass options\n\t  down `SPARQL.Query.new/2`, so it can also used with `default_prefixes`\n\n[Compare v0.2.2...v0.2.3](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.2...v0.2.3)","ref":"changelog.html#changed"},{"type":"extras","title":"v0.2.2 - 2018-09-22 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-2-2018-09-22"},{"type":"extras","title":"Added - CHANGELOG","doc":"- application-wide and query-specific ways to define default prefixes","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- bug in the lexer grammar which caused a scanner error on lowercase `distinct`\n\n[Compare v0.2.1...v0.2.2](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.1...v0.2.2)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.2.1 - 2018-09-17 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-1-2018-09-17"},{"type":"extras","title":"Fixed - CHANGELOG","doc":"- generated Erlang output files of Leex and Yecc are excluded from Hex package, \n  which caused issues using the SPARQL.ex Hex package on OTP < 21\n  (because the package was released with OTP 21)\n\n[Compare v0.2.0...v0.2.1](https://github.com/rdf-elixir/sparql-ex/compare/v0.2.0...v0.2.1)","ref":"changelog.html#fixed"},{"type":"extras","title":"v0.2.0 - 2018-09-17 - CHANGELOG","doc":"","ref":"changelog.html#v0-2-0-2018-09-17"},{"type":"extras","title":"Added - CHANGELOG","doc":"- SPARQL Query engine for executing queries against RDF.ex graphs \n  (not complete yet; see Current state section in README)","ref":"changelog.html#added"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- Elixir versions < 1.6 are no longer supported\n- renamed the `SPARQL.Query.ResultSet` struct to `SPARQL.Query.Result`\n- removed the previous `SPARQL.Query.Result` struct for single solutions; these \n  are now represented as simple maps\n\n\n[Compare v0.1.0...v0.2.0](https://github.com/rdf-elixir/sparql-ex/compare/v0.1.0...v0.2.0)","ref":"changelog.html#changed"},{"type":"extras","title":"v0.1.0 - 2018-03-19 - CHANGELOG","doc":"Initial release","ref":"changelog.html#v0-1-0-2018-03-19"},{"type":"extras","title":"CONTRIBUTING","doc":"1. Fork it (   )\n2. Create your feature branch (`git checkout -b my-new-feature`)\n3. Make your changes, with new passing tests. Follow this [style guide].\n4. Execute all tests.\n5. Commit your changes (`git commit -am 'Add some feature'`)\n6. Push to the branch (`git push origin my-new-feature`)\n7. Create a new Pull Request\n\n[style guide]:  https://github.com/christopheradams/elixir_style_guide","ref":"contributing.html"},{"type":"extras","title":"License","doc":"# MIT License\n\nCopyright (c) 2018-2020 Marcel Otto\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}